Index: codes/icosagcm/trunk/src/base/abort.F90
===================================================================
--- codes/icosagcm/trunk/src/base/abort.F90	(revision 926)
+++ codes/icosagcm/trunk/src/base/abort.F90	(revision 953)
@@ -17,3 +17,13 @@
     !$omp end single
   end subroutine
+
+  !!!Abort execution when openacc is on
+  subroutine abort_acc( message )
+    use mpi_mod
+    implicit none
+    character(len=*), optional, intent(in) :: message  
+#ifdef _OPENACC
+    call dynamico_abort( "Not tested with OpenACC ! " // message )
+#endif
+  end subroutine
 end module
Index: codes/icosagcm/trunk/src/base/field.f90
===================================================================
--- codes/icosagcm/trunk/src/base/field.f90	(revision 926)
+++ codes/icosagcm/trunk/src/base/field.f90	(revision 953)
@@ -13,7 +13,7 @@
   TYPE t_field
     CHARACTER(30)      :: name
-    REAL(rstd),POINTER :: rval2d(:)
-    REAL(rstd),POINTER :: rval3d(:,:)
-    REAL(rstd),POINTER :: rval4d(:,:,:)
+    REAL(rstd),POINTER :: rval2d(:) => null()
+    REAL(rstd),POINTER :: rval3d(:,:) => null()
+    REAL(rstd),POINTER :: rval4d(:,:,:) => null()
 
     INTEGER,POINTER :: ival2d(:)
@@ -30,4 +30,6 @@
     INTEGER :: dim3
     INTEGER :: dim4
+    
+    LOGICAL :: ondevice !< flag if field is allocated on device as well
   END TYPE t_field   
 
@@ -48,5 +50,5 @@
 CONTAINS
 
-  SUBROUTINE allocate_field(field,field_type,data_type,dim1,dim2,name)
+  SUBROUTINE allocate_field(field,field_type,data_type,dim1,dim2,name,ondevice)
   USE domain_mod
   USE omp_para
@@ -56,13 +58,16 @@
     INTEGER,OPTIONAL :: dim1,dim2
     CHARACTER(*), OPTIONAL :: name
+    LOGICAL, INTENT(IN), OPTIONAL :: ondevice 
 !$OMP BARRIER
 !$OMP MASTER
-    ALLOCATE(field(ndomain))
+    ALLOCATE(field(ndomain))    
 !$OMP END MASTER
 !$OMP BARRIER
-    CALL allocate_field_(field,field_type,data_type,dim1,dim2,name)
+
+    CALL allocate_field_(field,field_type,data_type,dim1,dim2,name,ondevice)
+    
   END SUBROUTINE allocate_field
 
-  SUBROUTINE allocate_fields(nfield,field,field_type,data_type,dim1,dim2,name)
+  SUBROUTINE allocate_fields(nfield,field,field_type,data_type,dim1,dim2,name, ondevice)
   USE domain_mod
   USE omp_para
@@ -73,4 +78,5 @@
     INTEGER,OPTIONAL :: dim1,dim2
     CHARACTER(*), OPTIONAL :: name
+    LOGICAL, INTENT(IN), OPTIONAL :: ondevice
     INTEGER :: i
 !$OMP BARRIER
@@ -80,9 +86,9 @@
 !$OMP BARRIER
     DO i=1,nfield
-       CALL allocate_field_(field(:,i),field_type,data_type,dim1,dim2,name)
+       CALL allocate_field_(field(:,i),field_type,data_type,dim1,dim2,name,ondevice)
     END DO
   END SUBROUTINE allocate_fields
 
-  SUBROUTINE allocate_field_(field,field_type,data_type,dim1,dim2,name)
+  SUBROUTINE allocate_field_(field,field_type,data_type,dim1,dim2,name,ondevice)
   USE domain_mod
   USE omp_para
@@ -93,4 +99,5 @@
     INTEGER,OPTIONAL :: dim1,dim2
     CHARACTER(*), OPTIONAL :: name
+    LOGICAL, INTENT(IN), OPTIONAL :: ondevice
     INTEGER :: ind
     INTEGER :: ii_size,jj_size
@@ -119,5 +126,5 @@
       field(ind)%data_type=data_type
       field(ind)%field_type=field_type
-    
+
       IF (field_type==field_T) THEN 
         jj_size=domain(ind)%jjm
@@ -131,17 +138,25 @@
         
       IF (field(ind)%ndim==4) THEN
-        IF (data_type==type_integer) ALLOCATE(field(ind)%ival4d(ii_size*jj_size,dim1,dim2))
-        IF (data_type==type_real)    ALLOCATE(field(ind)%rval4d(ii_size*jj_size,dim1,dim2))
-        IF (data_type==type_logical) ALLOCATE(field(ind)%lval4d(ii_size*jj_size,dim1,dim2))
+         IF (data_type==type_integer) ALLOCATE(field(ind)%ival4d(ii_size*jj_size,dim1,dim2))
+         IF (data_type==type_real)    ALLOCATE(field(ind)%rval4d(ii_size*jj_size,dim1,dim2))
+         IF (data_type==type_logical) ALLOCATE(field(ind)%lval4d(ii_size*jj_size,dim1,dim2))
+
       ELSE IF (field(ind)%ndim==3) THEN
-        IF (data_type==type_integer) ALLOCATE(field(ind)%ival3d(ii_size*jj_size,dim1))
-        IF (data_type==type_real)    ALLOCATE(field(ind)%rval3d(ii_size*jj_size,dim1))
-        IF (data_type==type_logical) ALLOCATE(field(ind)%lval3d(ii_size*jj_size,dim1))
+         IF (data_type==type_integer) ALLOCATE(field(ind)%ival3d(ii_size*jj_size,dim1))
+         IF (data_type==type_real)    ALLOCATE(field(ind)%rval3d(ii_size*jj_size,dim1))
+         IF (data_type==type_logical) ALLOCATE(field(ind)%lval3d(ii_size*jj_size,dim1))
+
       ELSE IF (field(ind)%ndim==2) THEN
-        IF (data_type==type_integer) ALLOCATE(field(ind)%ival2d(ii_size*jj_size))
-        IF (data_type==type_real)    ALLOCATE(field(ind)%rval2d(ii_size*jj_size))
-        IF (data_type==type_logical) ALLOCATE(field(ind)%lval2d(ii_size*jj_size))
-      ENDIF
-      
+         IF (data_type==type_integer) ALLOCATE(field(ind)%ival2d(ii_size*jj_size))
+         IF (data_type==type_real)    ALLOCATE(field(ind)%rval2d(ii_size*jj_size))
+         IF (data_type==type_logical) ALLOCATE(field(ind)%lval2d(ii_size*jj_size))
+
+      ENDIF
+
+      field(ind)%ondevice = .FALSE.
+      IF (PRESENT(ondevice)) THEN
+         IF (ondevice) CALL create_device_field(field(ind))
+      END IF
+   
    ENDDO
 !$OMP BARRIER
@@ -160,5 +175,5 @@
     INTEGER :: ii_size,jj_size
 
-    ALLOCATE(field(ndomain_glo))    
+    ALLOCATE(field(ndomain_glo)) 
 
     DO ind=1,ndomain_glo
@@ -184,4 +199,6 @@
       field(ind)%field_type=field_type
     
+      field(ind)%ondevice = .FALSE.
+
       IF (field_type==field_T) THEN 
         jj_size=domain_glo(ind)%jjm
@@ -251,23 +268,86 @@
     INTEGER :: ind
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
-
-      data_type=field(ind)%data_type
-        
-      IF (field(ind)%ndim==4) THEN
-        IF (data_type==type_integer) DEALLOCATE(field(ind)%ival4d)
-        IF (data_type==type_real)    DEALLOCATE(field(ind)%rval4d)
-        IF (data_type==type_logical) DEALLOCATE(field(ind)%lval4d)
-      ELSE IF (field(ind)%ndim==3) THEN
-        IF (data_type==type_integer) DEALLOCATE(field(ind)%ival3d)
-        IF (data_type==type_real)    DEALLOCATE(field(ind)%rval3d)
-        IF (data_type==type_logical) DEALLOCATE(field(ind)%lval3d)
-      ELSE IF (field(ind)%ndim==2) THEN
-        IF (data_type==type_integer) DEALLOCATE(field(ind)%ival2d)
-        IF (data_type==type_real)    DEALLOCATE(field(ind)%rval2d)
-        IF (data_type==type_logical) DEALLOCATE(field(ind)%lval2d)
-      ENDIF
-      
-   ENDDO
+       IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
+
+       data_type=field(ind)%data_type
+
+       IF (field(ind)%ndim==4) THEN
+          IF (data_type==type_integer) THEN
+             DEALLOCATE(field(ind)%ival4d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%ival4d)
+                CONTINUE
+             END IF
+          END IF
+
+          IF (data_type==type_real) THEN
+             DEALLOCATE(field(ind)%rval4d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%rval4d)
+                CONTINUE
+             END IF
+          END IF
+
+          IF (data_type==type_logical) THEN
+             DEALLOCATE(field(ind)%lval4d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%lval4d)
+                CONTINUE
+             END IF
+          END IF
+
+       ELSE IF (field(ind)%ndim==3) THEN
+          IF (data_type==type_integer) THEN
+             DEALLOCATE(field(ind)%ival3d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%ival3d)
+                CONTINUE
+             END IF
+          END IF
+
+          IF (data_type==type_real) THEN
+             DEALLOCATE(field(ind)%rval3d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%rval3d)
+                CONTINUE
+             END IF
+          END IF
+
+          IF (data_type==type_logical) THEN
+             DEALLOCATE(field(ind)%lval3d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%lval3d)
+                CONTINUE
+             END IF
+          END IF
+
+       ELSE IF (field(ind)%ndim==2) THEN
+          IF (data_type==type_integer) THEN
+             DEALLOCATE(field(ind)%ival2d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%ival2d)
+                CONTINUE
+             END IF
+          END IF
+
+          IF (data_type==type_real) THEN
+             DEALLOCATE(field(ind)%rval2d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%rval2d)
+                CONTINUE
+             END IF
+          END IF
+
+          IF (data_type==type_logical) THEN
+             DEALLOCATE(field(ind)%lval2d)
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%lval2d)
+                CONTINUE
+             END IF
+          END IF
+
+       ENDIF
+
+    ENDDO
   END SUBROUTINE deallocate_field_
 
@@ -460,3 +540,182 @@
   END SUBROUTINE  getval_l4d    
 
+
+  SUBROUTINE update_device_field(field)
+  USE domain_mod
+  USE omp_para
+  IMPLICIT NONE
+    TYPE(t_field) :: field(:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
+
+      IF (.NOT. field(ind)%ondevice) CALL create_device_field(field(ind))
+
+      IF (field(ind)%ndim==4) THEN
+         IF (field(ind)%data_type==type_integer) THEN
+            !$acc update device(field(ind)%ival4d(:,:,:))
+            CONTINUE
+         END IF
+
+         IF (field(ind)%data_type==type_real) THEN
+            !$acc update device(field(ind)%rval4d(:,:,:))
+            CONTINUE
+         END IF
+
+         IF (field(ind)%data_type==type_logical) THEN
+            !$acc update device(field(ind)%lval4d(:,:,:))
+            CONTINUE
+         END IF
+
+      ELSE IF (field(ind)%ndim==3) THEN
+         IF (field(ind)%data_type==type_integer) THEN
+            !$acc update device(field(ind)%ival3d(:,:))
+            CONTINUE
+         END IF
+
+         IF (field(ind)%data_type==type_real) THEN
+            !$acc update device(field(ind)%rval3d(:,:))
+            CONTINUE
+         END IF
+
+         IF (field(ind)%data_type==type_logical) THEN
+            !$acc update device(field(ind)%lval3d(:,:))
+            CONTINUE
+         END IF
+
+      ELSE IF (field(ind)%ndim==2) THEN
+         IF (field(ind)%data_type==type_integer) THEN
+            !$acc update device(field(ind)%ival2d(:))
+            CONTINUE
+         END IF
+
+         IF (field(ind)%data_type==type_real) THEN
+            !$acc update device(field(ind)%rval2d(:))
+            CONTINUE
+         END IF
+
+         IF (field(ind)%data_type==type_logical) THEN
+            !$acc update device(field(ind)%lval2d(:))
+            CONTINUE
+         END IF
+      ENDIF
+   ENDDO
+   !$OMP BARRIER
+ END SUBROUTINE update_device_field
+ 
+  SUBROUTINE update_host_field(field)
+  USE domain_mod
+  USE omp_para
+  IMPLICIT NONE
+    TYPE(t_field) :: field(:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)  .OR. .NOT. is_omp_level_master) CYCLE
+
+      IF (field(ind)%ondevice) THEN
+        
+         IF (field(ind)%ndim==4) THEN
+            IF (field(ind)%data_type==type_integer) THEN
+               !$acc update host(field(ind)%ival4d(:,:,:)) wait
+               CONTINUE
+            END IF
+
+            IF (field(ind)%data_type==type_real) THEN
+               !$acc update host(field(ind)%rval4d(:,:,:)) wait
+               CONTINUE
+            END IF
+
+            IF (field(ind)%data_type==type_logical) THEN
+               !$acc update host(field(ind)%lval4d(:,:,:)) wait
+               CONTINUE
+            END IF
+         
+         ELSE IF (field(ind)%ndim==3) THEN
+            IF (field(ind)%data_type==type_integer) THEN
+               !$acc update host(field(ind)%ival3d(:,:)) wait
+               CONTINUE
+            END IF
+
+            IF (field(ind)%data_type==type_real) THEN
+               !$acc update host(field(ind)%rval3d(:,:)) wait
+               CONTINUE
+            END IF
+
+            IF (field(ind)%data_type==type_logical) THEN
+               !$acc update host(field(ind)%lval3d(:,:)) wait
+               CONTINUE
+            END IF
+
+         ELSE IF (field(ind)%ndim==2) THEN
+            IF (field(ind)%data_type==type_integer) THEN
+               !$acc update host(field(ind)%ival2d(:)) wait
+               CONTINUE
+            END IF
+
+            IF (field(ind)%data_type==type_real) THEN
+               !$acc update host(field(ind)%rval2d(:)) wait
+               CONTINUE
+            END IF
+
+            IF (field(ind)%data_type==type_logical) THEN
+               !$acc update host(field(ind)%lval2d(:)) wait
+               CONTINUE
+            END IF
+         ENDIF
+      END IF
+   ENDDO
+   !$OMP BARRIER
+ END SUBROUTINE update_host_field
+
+ SUBROUTINE create_device_field(field)
+    TYPE(t_field) :: field
+
+    IF (field%ondevice) THEN
+       PRINT *, "Field is already on device !"
+       STOP 1
+    END IF
+    IF (field%ndim==4) THEN
+       IF (field%data_type==type_integer) THEN
+          !$acc enter data create(field%ival4d(:,:,:))
+       END IF
+
+       IF (field%data_type==type_real) THEN
+          !$acc enter data create(field%rval4d(:,:,:))
+       END IF
+
+       IF (field%data_type==type_logical) THEN
+          !$acc enter data create(field%lval4d(:,:,:))
+       END IF
+
+    ELSE IF (field%ndim==3) THEN
+       IF (field%data_type==type_integer) THEN
+          !$acc enter data create(field%ival3d(:,:))
+       END IF
+
+       IF (field%data_type==type_real) THEN
+          !$acc enter data create(field%rval3d(:,:))
+       END IF
+
+       IF (field%data_type==type_logical) THEN
+          !$acc enter data create(field%lval3d(:,:))
+       END IF
+
+    ELSE IF (field%ndim==2) THEN
+       IF (field%data_type==type_integer) THEN
+          !$acc enter data create(field%ival2d(:))
+       END IF
+
+       IF (field%data_type==type_real) THEN
+          !$acc enter data create(field%rval2d(:))
+       END IF
+
+       IF (field%data_type==type_logical) THEN
+          !$acc enter data create(field%lval2d(:))
+       END IF
+    ENDIF
+    field%ondevice = .TRUE.
+  END SUBROUTINE create_device_field
+ 
 END MODULE field_mod   
Index: codes/icosagcm/trunk/src/diagnostics/check_conserve.f90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/check_conserve.f90	(revision 926)
+++ codes/icosagcm/trunk/src/diagnostics/check_conserve.f90	(revision 953)
@@ -1,4 +1,5 @@
 MODULE check_conserve_mod
   USE icosa 
+  USE abort_mod
   IMPLICIT NONE 
 
@@ -28,4 +29,5 @@
     USE getin_mod
     USE omp_para, ONLY : is_master
+    USE abort_mod
     CHARACTER(LEN=255) :: check_type_str
     CALL allocate_field(f_pk,field_t,type_real,llm)
@@ -47,4 +49,8 @@
        STOP
     END SELECT
+
+    IF (check_type /= check_basic) THEN
+       CALL abort_acc("check_conservation /= 'basic'")
+    END IF
   END SUBROUTINE init_check_conserve
 
@@ -179,5 +185,5 @@
     
     IF(check_type == check_detailed) THEN
-
+       CALL abort_acc("!check_detailed")
        CALL transfert_request(f_ue,req_e1_vect)
        CALL pression(f_ps,f_p)
Index: codes/icosagcm/trunk/src/diagnostics/diagflux.F90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/diagflux.F90	(revision 926)
+++ codes/icosagcm/trunk/src/diagnostics/diagflux.F90	(revision 953)
@@ -21,7 +21,12 @@
   SUBROUTINE init_diagflux
     USE getin_mod
+    USE abort_mod
     INTEGER :: ll
     diagflux_on = .FALSE.
     CALL getin("diagflux", diagflux_on)
+    IF (diagflux_on) THEN
+       CALL abort_acc("diagflux /= .FALSE.")
+    END IF
+
     ll = MERGE(llm,1,diagflux_on)
     CALL allocate_field(f_masst,         field_t,type_real,ll,       name="masst")
Index: codes/icosagcm/trunk/src/diagnostics/observable.f90
===================================================================
--- codes/icosagcm/trunk/src/diagnostics/observable.f90	(revision 926)
+++ codes/icosagcm/trunk/src/diagnostics/observable.f90	(revision 953)
@@ -30,5 +30,5 @@
     CALL allocate_field(f_buf_s,   field_t,type_real, name="buf_s")
 
-    CALL allocate_field(f_theta, field_t,type_real,llm,nqdyn,  name='theta') ! potential temperature
+    CALL allocate_field(f_theta, field_t,type_real,llm,nqdyn,  name='theta', ondevice=.TRUE.) ! potential temperature
     CALL allocate_field(f_pmid,  field_t,type_real,llm,  name='pmid')       ! mid layer pressure
   END SUBROUTINE init_observable
@@ -56,4 +56,5 @@
 
     CALL transfert_request(f_ps,req_i1)
+    CALL update_host_field(f_ps)
     
     IF(init) THEN
@@ -109,5 +110,5 @@
     
     CALL progonostic_vel_to_horiz(f_geopot, f_ps, f_mass, f_u, f_W, f_buf_uh, f_buf_i)
-    CALL transfert_request(f_buf_uh,req_e1_vect) 
+    CALL transfert_request(f_buf_uh,req_e1_vect)
     CALL un2ulonlat(f_buf_uh, f_buf_ulon, f_buf_ulat)
     IF(init) THEN
